import { IncomingMessage, ServerResponse } from 'http';
import { Server } from 'http';
export interface IHeaderName {
    'Access-Control-Allow-Origin': any;
}
export interface IServerconfig<H = IHeaderName> {
    port: number;
    message: string;
    publicDir: string;
    header: {
        name: keyof Extract<H, IHeaderName>;
        value: string | number | string[];
    };
    Logger: Partial<{
        method: boolean;
        api: boolean;
        pathname: boolean;
        value: boolean;
    }>;
}
export declare type IRequestListener = (request: IncomingMessage, response: ServerResponse) => void;
export declare type IMiddleWare = IRequestListener;
export declare type ICreateHttpServer = (config: IServerconfig, applyMiddleware?: IMiddleWare) => IRequestListener;
export declare type IConfigListener = (server: IServerconfig, applyMiddleware?: IMiddleWare) => (createHttpServer: ICreateHttpServer) => Server;
export declare const HttpServer: ({ port, message, header, publicDir, Logger }?: Partial<IServerconfig<IHeaderName>>, applyMiddleware?: IRequestListener) => Server;
export declare const getPostValue: (req: IncomingMessage) => Promise<string>;
